<template>
  <section class="flex items-center gap-2 text-2xl text-gray-400 font-light uppercase mb-6">
    <v-icon icon="mdi-calendar-month-outline" />
    За месяц
  </section>

  <MonthlyStatsSkeleton v-if="isLoading" />

  <section
    v-if="!isLoading"
    class="mb-4"
  >
    <PropertyFilter
      v-model="selectedProperty"
      class="w-full md:w-[316px]"
      clearable
    />
  </section>

  <section
    v-if="!isLoading"
    class="grid grid-cols-12 gap-4 md:gap-6"
  >
    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-calendar-outline">
        Выбор месяца
      </SectionHeader>

      <PluginCalendar
        :locale="{ id: 'ru', masks: { weekdays: 'WW' } }"
        class="w-full rounded-none shadow-none border-0"
        :min-date="calendarBoundaries.start"
        :max-date="calendarBoundaries.end"
        :attributes="highlightAttributes"
        :initial-page="{
          month: new Date().getMonth() + 1,
          year: new Date().getFullYear(),
        }"
        @did-move="onPageChange"
      >
        <template #day-popover="props">
          <section class="p-2">
            <section class="text-sm text-gray-600 text-center">
              {{ props['day-title'] }}
            </section>

            <section
              v-for="{ key, customData: booking } in props.attributes"
              :key="key"
              class="mt-2"
            >
              <section
                v-if="!selectedProperty || (selectedProperty.id === booking.property.id)"
                class="flex items-center gap-2"
              >
                <BookingStatusDisplay
                  :value="booking.status"
                  size="small"
                />

                <v-btn
                  v-tooltip="{ text: 'Нажмите, чтобы перейти', openOnClick: true }"
                  variant="tonal"
                  size="small"
                  @click="$router.push({
                    path: `/bookings/${booking.id}`,
                    query: { fromDashboard: 'true' },
                  })"
                >
                  <template #prepend>
                    <section
                      class="w-2 h-2 rounded-full"
                      :style="{ backgroundColor: booking.property.color }"
                    />
                  </template>

                  <section class="flex items-center gap-1">
                    <span>
                      {{ booking.property.name }}
                    </span>

                    <span class="text-gray-500 text-sm">
                      {{ '#' + String(booking.id).padStart(4, '0') }}
                    </span>
                  </section>

                  <template #append>
                    <v-icon icon="mdi-open-in-new" />
                  </template>
                </v-btn>
              </section>
            </section>
          </section>
        </template>
      </PluginCalendar>
    </Container>

    <section class="col-span-12 xl:col-span-6 grid grid-cols-12 gap-4 md:gap-6">
      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-cash-multiple"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <ProfitDisplay
              mode="display"
              :value="stats.totalProfit"
              disable-label
            />

            <section class="text-gray-400 text-sm">
              Суммарная прибыль
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-circle-multiple-outline"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <ProfitDisplay
              mode="display"
              :value="stats.averageProfit"
              disable-label
            />

            <section class="text-gray-400 text-sm">
              Средняя прибыль
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-account-multiple"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.totalGuests }} {{ getGuestsLabel(stats.totalGuests) }}
            </section>

            <section class="text-gray-400 text-sm">
              Суммарное кол-во
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-account-arrow-up-outline"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.averageGuests }} {{ getGuestsLabel(stats.averageGuests) }}
            </section>

            <section class="text-gray-400 text-sm">
              В среднем
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-star"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section class="truncate">
            <section
              v-tooltip:top-start="{ text: stats.favoriteProperty.name, openOnClick: true }"
              class="text-xl truncate"
            >
              {{ stats.favoriteProperty.name }}
            </section>

            <section class="text-gray-400 text-sm">
              Самый популярный
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-calendar-multiselect-outline"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.bookingsCount }} {{ getTimesLabel(stats.bookingsCount) }}
            </section>

            <section class="text-gray-400 text-sm">
              Бронировали
            </section>
          </section>
        </section>
      </Container>
    </section>

    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-cash-fast">
        Прибыль
      </SectionHeader>

      <Chart
        :options="{
          type: 'line',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Прибыль',
                backgroundColor: 'rgba(14, 144, 135, 0.2)',
                borderColor: 'rgba(14, 144, 135, 1)',
                borderWidth: 2,
                data: stats.profitGraphData,
                fill: 'start',
              },
            ],
          },
          options: {
            responsive: true,
            scales: { y: { beginAtZero: true } },
            elements: { line: { tension: 0.4 } },
            plugins: {
              filler: { propagate: false },
              tooltip: {
                callbacks: { title: ([{ label }]) => getTooltipTitle(label) }
              }
            },
            interaction: {
              intersect: false,
            }
          },
        }"
      />
    </Container>

    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-briefcase-account-outline">
        Гости
      </SectionHeader>

      <Chart
        :options="{
          type: 'line',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Гости',
                backgroundColor: 'rgba(14, 144, 135, 0.2)',
                borderColor: 'rgba(14, 144, 135, 1)',
                borderWidth: 2,
                data: stats.guestsGraphData,
                fill: 'start',
              },
            ],
          },
          options: {
            responsive: true,
            scales: { y: { beginAtZero: true } },
            elements: { line: { tension: 0.4 } },
            plugins: {
              filler: { propagate: false },
              tooltip: {
                callbacks: { title: ([{ label }]) => getTooltipTitle(label) }
              }
            },
            interaction: {
              intersect: false,
            }
          },
        }"
      />
    </Container>
  </section>

  <v-overlay
    :model-value="isOverlayLoading"
    class="items-center justify-center"
    scrim="white"
    persistent
  >
    <v-progress-circular
      color="var(--tw-color-teal-600)"
      size="64"
      indeterminate
    />
  </v-overlay>
</template>

<script setup lang="ts">
import { onMounted, reactive, ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { useDateTime } from '@/composables';
import { getGuestsLabel, getTimesLabel } from '@/utils';

import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import Chart from '@/components/content/Chart.vue';
import BookingStatusDisplay from '@/components/content/BookingStatusDisplay.vue';

import PropertyFilter from '@/pages/bookings/filters/PropertyFilter.vue';
import MonthlyStatsSkeleton from '@/components/skeletons/MonthlyStatsSkeleton.vue';

type SelectedPage = {
  year: number;
  month: number;
}

const emit = defineEmits(['loading:start', 'loading:end']);
const dt = useDateTime();

const isLoading = ref(false);
const isOverlayLoading = ref(false);

const selectedProperty = ref<IProperty | null>(null);

const calendarBoundaries = ref({ start: new Date(), end: new Date() });
const highlightAttributes = ref<any[]>([]);

const selectedPage = ref<SelectedPage>({
  year: new Date().getFullYear(),
  month: new Date().getMonth() + 1,
});

const getLabels = () => {
  const daysCount = dt.origin.local(
    selectedPage.value.year,
    selectedPage.value.month,
    1
  ).daysInMonth;

  return Array.from({ length: Number(daysCount) }, (_, index) => {
    return String(index + 1);
  });
};

const getTooltipTitle = (label: string) => {
  const day = dt.origin.local(
    selectedPage.value.year,
    selectedPage.value.month,
    Number(label),
    { locale: 'ru' },
  );

  return day.toFormat('d MMMM yyyy');
};

const labels = reactive(getLabels());
const stats = reactive({
  totalProfit: 0,
  averageProfit: 0,
  totalGuests: 0,
  averageGuests: 0,
  bookingsCount: 0,
  favoriteProperty: {
    name: 'Нет данных'
  },
  profitGraphData: [],
  guestsGraphData: [],
});

const startLoading = (type: 'skeleton' | 'overlay') => {
  if (isLoading.value) return;

  if (type === 'skeleton') isLoading.value = true;
  if (type === 'overlay') isOverlayLoading.value = true;

  emit('loading:start');
};

const stopLoading = (type: 'skeleton' | 'overlay') => {
  if (type === 'skeleton') isLoading.value = false;
  if (type === 'overlay') isOverlayLoading.value = false;

  emit('loading:end');
};

const onPageChange = ([page]: any[]) => {
  selectedPage.value = { year: page.year, month: page.month };
};

const getHighlighterOptions = (booking: IVerboseBooking) => {
  const color = booking.property.color;

  if (selectedProperty.value) {
    return {
      highlight: {
        start: {
          contentStyle: { color },
          style: { borderColor: color },
          fillMode: 'outline',
        },
        base: {
          style: { backgroundColor: color, opacity: 0.6 },
          fillMode: 'light',
        },
        end: {
          contentStyle: { color },
          style: { borderColor: color },
          fillMode: 'outline',
        },
      },
    };
  }

  return {
    bar: { style: { backgroundColor: color, height: '6px' } },
  };
};

const loadBoundaries = async () => {
  const { data: { values, error } } = (
    await HttpClient.get('/v1/dashboard/boundaries')
  );

  if (error) {
    return true;
  }

  calendarBoundaries.value = values;

  const minBoundary = new Date(values.start);
  const maxBoundary = new Date(values.end);

  const isBeforeMin = Date.now() < Number(minBoundary);
  const isAfterMax = Date.now() > Number(maxBoundary);

  if (!isBeforeMin && !isAfterMax) {
    return true;
  }

  const min = dt.wrap(minBoundary);

  onPageChange([
    { year: min.year, month: min.month },
  ]);

  return false;
};

const getRequestParams = () => {
  const year = selectedPage.value.year;
  const month = selectedPage.value.month;

  const searchStart = dt.origin
    .local(year, month, 1)
    .startOf('month')
    .set({ hour: 13, minute: 59, second: 59, millisecond: 999 });

  const searchEnd = dt.origin
    .local(year, month, 1)
    .endOf('month');

  const propertyId = selectedProperty.value?.id;

  return {
    start: encodeURIComponent(searchStart.toISO()!),
    end: encodeURIComponent(searchEnd.toISO()!),
    ...(propertyId && { propertyId }),
  };
};

const loadCalendarData = async () => {
  highlightAttributes.value = [];

  const { data: { values: bookings } } = (
    await HttpClient.get<IVerboseBooking[]>('/v1/bookings/range', {
      params: getRequestParams(),
    })
  );

  highlightAttributes.value = (bookings ?? []).map(booking => {
    const start = dt.wrap(booking.startDate).toLocal();
    const end = dt.wrap(booking.endDate).toLocal();

    const highlighterOptions = getHighlighterOptions(booking);

    return {
      key: booking.id,
      dates: { start: start.toISO(), end: end.toISO() },
      popover: { visibility: 'click' },
      customData: booking,
      ...highlighterOptions,
    };
  });
};

const loadMonthlyStats = async () => {
  const { data: { values, error } } = (
    await HttpClient.get('/v1/dashboard/stats/monthly', {
      params: getRequestParams(),
    })
  );

  if (error) return;

  stats.totalProfit = values.totalProfit;
  stats.averageProfit = values.averageProfit;
  stats.totalGuests = values.totalGuests;
  stats.averageGuests = values.averageGuests;
  stats.bookingsCount = values.bookingsCount;
  stats.favoriteProperty = values.favoriteProperty;
  stats.profitGraphData = values.profitGraphData;
  stats.guestsGraphData = values.guestsGraphData;

  labels.length = 0;
  labels.push(...getLabels());
};

watch(selectedPage, async () => {
  startLoading('overlay');
  await Promise.all([loadCalendarData(), loadMonthlyStats()]);
  stopLoading('overlay');
});

watch(selectedProperty, async () => {
  startLoading('overlay');
  await Promise.all([loadCalendarData(), loadMonthlyStats()]);
  stopLoading('overlay');
});

onMounted(async () => {
  startLoading('skeleton');

  const isAcknowledged = await loadBoundaries();

  if (!isAcknowledged) {
    stopLoading('skeleton');
    return;
  }

  await Promise.all([
    loadCalendarData(),
    loadMonthlyStats(),
  ]);

  stopLoading('skeleton');
});
</script>